#!/system/bin/sh
TMOBILE_PATH="/data/data/com.tmobile.myfaves/databases/"
NORMAL_PATH="/data/data/com.android.providers.contacts/databases/"

DB_PATH=$NORMAL_PATH

if [ -e $TMOBILE_PATH ] ; then
    DB_PATH=$TMOBILE_PATH
fi

SQLITE3=`which sqlite3`
if [ "$SQLITE3" = "" ] ; then
    SQLITE3="/data/patch/sqlite3"
fi

cd $DB_PATH

echo 'Phase 1: Creating triggers...'
#Replace the offical trigger to index email address
$SQLITE3 contacts.db "DROP TRIGGER IF EXISTS peopleLookup_update;"
$SQLITE3 contacts.db \
"CREATE TRIGGER peopleLookup_update \
UPDATE OF name ON people \
BEGIN\
  DELETE FROM peopleLookup WHERE source = new._id;\
  SELECT _TOKENIZE('peopleLookup', new._id, new.name, ' ');\
  SELECT _TOKENIZE('peopleLookup', new._id, data, '')\
    FROM contact_methods\
	WHERE person=new._id AND kind=1; \
END" 

# Trig the peopleLookup_updats trigger
$SQLITE3 contacts.db "DROP TRIGGER IF EXISTS sunner_email_update;"
$SQLITE3 contacts.db \
"CREATE TRIGGER IF NOT EXISTS sunner_email_update \
AFTER UPDATE OF data ON contact_methods \
WHEN new.kind=1 \
BEGIN \
  UPDATE people SET name=\`name\` WHERE _id=new.person; \
END" 

$SQLITE3 contacts.db \
"CREATE TRIGGER IF NOT EXISTS sunner_email_insert \
AFTER INSERT ON contact_methods \
WHEN new.kind=1 \
BEGIN \
  SELECT _TOKENIZE('peopleLookup', new.person, new.data, ''); \
END" 

echo 'Phase 2: Updating database...slowly......'
$SQLITE3 contacts.db 'UPDATE people SET name=`name`;'
echo 'Phase 3: Reindexing database...'
$SQLITE3 contacts.db 'reindex peopleNameIndex;'
$SQLITE3 contacts.db 'reindex peopleLookupIndex;'
echo 'Finish! Enjoy Android! Enjoy Open Source!'
echo 'Send comments and donation to sunner@gmail.com'
